#include "BinaryData.h"

BinaryData::BinaryData(unsigned int bit_fuction,int dim)
{
    CreateDataFromBooleanFunction(bit_fuction,dim);
}

int BinaryData::GetBit(unsigned int number,int position)
{
   if(position> 32 ) return 0;
   return (number & (1 << position-1)) >> position-1;
}

void BinaryData::CreateBooleanFunction(unsigned int bit_function,int dim)
{
    //ClearDataSet();

    number_of_features=dim;
 //   int number_of_classes=2;
//    Label labels[]={1,0};
    number_of_signal_vectors = (1 << dim);
    
    if(dim > 5 )
        cerr << "Worning: actualy can't fully represent all functions with dim > 5\n";
    
    CreateEmptyDataTable( number_of_signal_vectors , number_of_features);

    for(unsigned long i=0;i<number_of_signal_vectors;i++)
    {
        for(unsigned long j=0;j<number_of_features;j++)
            signal[i]->InputS[j]=GetBit(i,number_of_features-j);

        signal[i]->classLabel= GetBit(bit_function,number_of_signal_vectors-i);
     }
     RefreshDataInfo();
}

void BinaryData::CreateDataFromBooleanFunction(unsigned int bit_function,int dim)
{
    CreateBooleanFunction(bit_function,dim);
}

void BinaryData::CreateParityFunction(int dim)
{
    CreateBooleanFunction(0,dim);

    for(unsigned long i=0;i<number_of_signal_vectors;i++)
    {
        int bits_on=0;
        for(unsigned long j=0;j<number_of_features;j++)
            if(signal[i]->InputS[j]) bits_on++;
        if(bits_on%2) signal[i]->classLabel=1;
            else signal[i]->classLabel=0;
    }
    CreateDiagonalReprezentationOfLabels();
}

void BinaryData::CreateRandomBooleanFunction( int dim, float probability )
{
    if(probability > 1 || probability < 0) throw new Exception("Bad probability value");
            
            
    CreateBooleanFunction(0,dim);
    for(unsigned long i=0;i<number_of_signal_vectors;i++)
    {
        float chanse = rand()/(float)RAND_MAX;
        if(chanse < probability ) signal[i]->classLabel = 1;
        else signal[i]->classLabel = 0;
    }
    CreateDiagonalReprezentationOfLabels();



}

void BinaryData::DataLabelDiffuzion( int diffCount )
{
    //cout << "\n diff " << diffCount; 
    if(diffCount > this->number_of_signal_vectors) 
        throw new Exception("Too big diffCount number in DataLabelDiffuzion");
    
    RandomID rand(number_of_signal_vectors);
    
    for(int i=0;i<diffCount;i++)
    {
        int id = rand.Next();
      //  cout << id << " ";
        if(signal[id]->classLabel == 1.0 ) signal[id]->classLabel = 0.0;
            else signal[id]->classLabel = 1.0;        
    }
    CreateDiagonalReprezentationOfLabels();
}

void BinaryData::DataLabelDiffuzion( float diffFraction )
{
    int diffCount = (int)(this->number_of_signal_vectors * diffFraction) ;
    DataLabelDiffuzion(diffCount);

}
