#include "BitVector.h"

void BitVector::Clear(int state)
{
		if(state==0)
			for(long i=0;i<nr_of_long;i++)	bits[i]=0;
		else
			for(long i=0;i<size;i++) SetBitOn(i);
}

int BitVector::Count( int state )
{
    int count = 0;
    for(int i=0;i<size;i++) if(GetBit( i ) == state) count++;
    return count;
}


BitVector::BitVector(BitVector &bv)
{
	CreateBitVector(bv.size);
	for(long i=0;i<bv.nr_of_long;i++)
		bits[i]=bv.bits[i];
}

void BitVector::CreateBitVector(long s)
{
	size=s;
	size_of_long=sizeof(unsigned long);
	if(s==0)
	{
		bits=NULL;
		nr_of_long=0;
		return;
	}
	nr_of_long=1+(long)((s-1)/size_of_long);
	
	bits = new unsigned long[nr_of_long];
	if(!bits) throw new MemoryException("bitvector not created");
	Clear();
}

int BitVector::GetBit(long i)
{
	if(i>=size) throw new Exception("Blad - za daleko w bit wektorze\n");
	long n = i/size_of_long;
	int r =i%size_of_long;

	return (((long)1 << r)&bits[n])>>r;
}

void BitVector::SetBit(long i, int state)
{
	long n = i/size_of_long;
	int r =i%size_of_long;
	if(state)
		bits[n]=bits[n]|(1 << r);
	else	
		bits[n]=bits[n]^(1 << r);
}	
