
#ifndef __BITVECTOR_H
#define __BITVECTOR_H
#include <iostream>
#include "exceptions.h"

using namespace std;

class BitVector
{
	unsigned long *bits;
	long size;	
	long nr_of_long;
	int size_of_long;
	void CreateBitVector(long size);

public:
	BitVector()
	{
		CreateBitVector(0);
	};

	BitVector(BitVector &bv);

	BitVector(long s)
	{
		CreateBitVector(s);
	};

	void Clear(int state=0);

	~BitVector()
	{
		if (bits) delete [] bits;
		size=0;
	}
	
	int Count(int state);
	
	int operator[](long i)
	{
		return GetBit(i);
	}

	int GetBit(long i);

	void SetBitOn(long i)
	{
		SetBit(i,1);
	}

	void SetBitOff(long i)
	{
		SetBit(i,0);
	}

	void SetBit(long i,int state);

	BitVector& operator~()
	{
		for(long i=0;i<nr_of_long;i++)
			bits[i]=~bits[i];
		return *this;
	}

	long Size()
	{
		return size;
	}

	friend ostream& operator<<(ostream& o,BitVector &bv)
	{
		for(long i=0;i<bv.size;i++)
			o << bv.GetBit(i);
		return o;
	}
};
#endif
