//
// C++ Implementation: DataTemperatureReprezentation
//
// Description: 
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include "DataTemperatureReprezentation.h"
Data * DataTemperatureReprezentation::Learn( Data * trainData )
{
    long features = trainData->GetNumberOfFeatures();
    long vectors = trainData->GetNumberOfVectors();
    
    //tworzymy tablice reprezentujaca grupy etykiet dla kazdej z cech, powinna byz zmienna prywatna
    lrTable = new LabelsReprezentation[features];
    
    float *featureValue = new float[vectors];
    
    // wypelniamy ja wartosciami
    for(long f=0;f<features;f++)
    {
            
         for(long v=0;v<vectors;v++)
         {
        //kopiowanie do tablicy
            float *input = trainData->GetInput( v );
            featureValue[v]= input[f];
        }
        lrTable[f].CreateDiagonalReprezentation(featureValue,vectors);
    }
    
    for(int f=0;f<features;f++)
    {
        cout << "\n Cecha nr. " << f << endl;
        cout << lrTable[f];
    
    }
    
    // wybieramy te ktore wydaja sie kategoriami, np size < 10
    return Run(trainData);
}

Data * DataTemperatureReprezentation::Run( Data * dataToTransform )
{
    long features = dataToTransform->GetNumberOfFeatures();
    long vectors = dataToTransform->GetNumberOfVectors();
    long newFeatures = 0;
  
    for(long f=0;f<features;f++)
        newFeatures += lrTable[f].GetNumberOfLabels();
    
    Data *newdata = new Data();
    newdata->CreateEmptyDataTable( vectors , newFeatures );
    
    for(long v=0;v<vectors;v++)
    {
        float *src=dataToTransform->GetInput( v);
        float *dst=newdata->GetInput( v);
        int featureId = 0;
        
        for(long f=0;f<features;f++) 
        {
            int ii = lrTable[f].GetNumberOfLabels();
            float *out = lrTable[f].Label2Output(src[f]);
            for(int fi=0;fi<ii;fi++)
               dst[featureId++]=out[fi];
        }
        newdata->SetLabel(v,dataToTransform->GetLabel( v));
        
    }
    newdata->RefreshDataInfo();
    return newdata;
}

void DataTemperatureReprezentation::Reset( )
{
    if(lrTable) delete lrTable;
    lrTable = NULL;
}
