/***************************************************************************
 *   Copyright (C) 2007 by Marek Grochowski   *
 *   marek@is.umk.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef __INCONSIDTENTSFILTER_H
#define __INCONSIDTENTSFILTER_H

#include <iostream>
#include "Model.h"
#include "Data.h"
#include "exceptions.h"
#include "Parameters.h"
#include "BitVector.h"


class InconsistencyFilter: public Transformation
{
    BitVector *inconsistentVectors;
    int inconsistentVectorsCount;
    int *inconsistentVectorsIdTable;       
    
    bool EqualPattern(float *pat1,float *pat2,int n);
    
    public :
        InconsistencyFilter():inconsistentVectorsIdTable(NULL),inconsistentVectorsCount(0),inconsistentVectors(NULL)
            {};
            
        void Configure(Parameters &p)
            {};
            
        Data* Learn(Data *d);
        Data* Run(Data *d);
        ~InconsistencyFilter();
        
   friend ostream& operator<<(ostream& o,InconsistencyFilter &ic)
	{
      o << "Inconsistent vectors: ";
      if(ic.inconsistentVectorsCount == 0) 
            o << "none";
      else	
            for(long i=0;i<ic.inconsistentVectorsCount;i++) 
                    o << ic.inconsistentVectorsIdTable[i] << " ";
		o << endl;
		return o;
	}
};

#endif