//
// C++ Implementation: KernelFunctions
//
// Description: 
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "KernelFunctions.h"

float KernelFunctions::Gauss( float * v1, float * v2, long dim )
{
    float sum = 0.0;
    float tmp = 0.0;
    
    for(long i=0;i<dim;i++)
    {
        tmp = *v1++ - *v2++;
        sum+= tmp*tmp;
    }
    return exp(-0.5*sum);

}

float KernelFunctions::InerProduct( float * v1, float * v2, long dim )
{
    float sum=0.0;
    
    for(long i=0;i<dim;i++)
    {
        sum+=*v1++ * *v2++;
    }
    return sum;
}
