//
// C++ Interface: KernelTransformation
//
// Description: 
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef _KERNELTRANSFORMATION_H
#define _KERNELTRANSFORMATION_H

#include "Data.h"
#include "Model.h"
#include "exceptions.h"
#include "KernelFunctions.h"
#include "BitVector.h"
#include <math.h>
#include "RandomID.h"

class KernelTransformation : public Transformation
{
    float (*KernelFunction)(float *v1,float *v2,long dim);
    long number_of_vectors;
    long number_of_features;
        
    float **vectors;
        
    float a;
    int Cryterium(float *v1,float *v2,int dim);
public:
    
    KernelTransformation():number_of_vectors(0),number_of_features(0),a(0.9),vectors(NULL),KernelFunction(KernelFunctions::InerProduct)
    {
        };
    
    Data* Learn(Data *trainData); 
	 Data* Run(Data *dataToTransform);
	 void SetKernel(int i);
	 void SetAlfa(float value){a = value;}
    void Configure( Parameters &p);
	 void Reset()	{ };
    ~KernelTransformation();
    void DisplayKernels();
};
#endif
