//
// C++ Implementation: LabelsReprezentation
//
// Description: 
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include "LabelsReprezentation.h"


LabelsReprezentation::LabelsReprezentation( )
{
    numberOfLabels = 0;
}

LabelsReprezentation::LabelsReprezentation(Label *labelTable,int size)
{
//    labelsInfoTable = NULL;
    numberOfLabels = 0;
    CreateDiagonalReprezentation(labelTable,size);
}

void LabelsReprezentation::CreateDiagonalReprezentation(Label *labelTable,int size)
{
    Clear();
    
    for(int i=0;i<size;i++)
    {
        Label l = labelTable[i];
        int poz = Find(l);
        if(poz == -1) 
        {
            LabelInfo *li = new LabelInfo(l);
            li->numberOfVectors = 1;
            labelsInfoTable.push_back(*li);
            numberOfLabels ++;
        }
        else
            labelsInfoTable[poz].numberOfVectors++;
    }
    
    for(int i=0;i<numberOfLabels;i++)
    {
        labelsInfoTable[i].CreateDiagonalReprezentation(i,numberOfLabels);
    }
}

int LabelsReprezentation::GetNumberOfLabels( )
{
    return numberOfLabels;
}

LabelsReprezentation::~ LabelsReprezentation( )
{
    Clear();
}

float * LabelsReprezentation::Label2Output( Label label )
{
    return labelsInfoTable[Find(label)].reprezentationTable;
}

int LabelsReprezentation::Find( Label label )
{
    for(int i=0;i<numberOfLabels;i++)
        if(labelsInfoTable[i].label==label) return i;
        
    return -1;
}

Label LabelsReprezentation::GetLabel( int id )
{
    if(id < 0 || id >= numberOfLabels ) throw new Exception("Wrong label id");
    return labelsInfoTable[id].label;
}

void LabelsReprezentation::Clear( )
{
    labelsInfoTable.clear();
    numberOfLabels =0;
}


int LabelsReprezentation::GetNumberOfVectorsInClass( int c )
{
    return labelsInfoTable[c].numberOfVectors;
}

