#ifndef __MODEL_H
#define __MODEL_H

#include "Parameters.h"
#include "Results.h"
#include "Data.h"

class Model
{
protected:
	char *model_name;
public:
	Model():model_name(NULL)
		{};
	virtual void Configure(Parameters &p)=0;
};


class Classifier : public Model
{

protected:
	Data *data;

public:
	virtual void Learn(Data *d)=0;
	virtual Label Test(float *v)=0;
	virtual void Save(char *flie)=0;
	virtual void Load(char *file)=0;
	virtual void Reset()=0;
	virtual Label* TestData(Data *d);
};

class Tester : public Model
{
protected:
	Model *model;
	Results test_results,train_results;
public:

	Tester()
	{
		model=NULL;
	}

	virtual void AddModel(Model *m)=0;	//na razie mozna dodawac tylko pojedynczy model do testu
	virtual void Run(Data *d)=0;
	virtual void DisplayResults()=0;
	virtual Results *GetResults()=0;
	virtual Results &GetTestResults()
	{
		return test_results;
	}
	virtual Results &GetTrainResults()
	{
		return train_results;
	}

	virtual void Reset()
	{
		test_results.Clear();
		train_results.Clear();
	}

};


class Transformation : public Model
{
protected:
    
public:

	Transformation()
	{	};

   virtual Data* Learn(Data *trainData)=0; 
	virtual Data* Run(Data *dataToTransform)=0;

	virtual void Reset()	{ };
};


#endif


