#include "Normalization.h"

Data* Normalization::Learn( Data * d )
{
    nr_number_of_features = d->GetNumberOfFeatures();
    
    if (!max) delete [] max;  
    if (!min) delete [] min;  
    max = new float[nr_number_of_features];
    min = new float[nr_number_of_features];
    if(!max || !min) throw new MemoryException("Normalization::Learn exception");
    
    
    for(int i=0 ; i<nr_number_of_features ; i++)
    {
        DataStatistics ds = d->GetStatisticsOfFeature( i);
        max[i]=ds.max;
        min[i]=ds.min;
    }
        
    return Run(d);
}

Normalization::~ Normalization( )
{
    delete [] max;
    delete [] min;
}

Data * Normalization::Run( Data * d )
{
    Data *newdata=d->Clone();
    float *input=NULL;
    unsigned long nr_vectors = d->GetNumberOfVectors();
    
    for(unsigned long v=0 ;v<nr_vectors; v++)
    {
        input=newdata->GetInput(v);
        for(unsigned long f=0 ; f<nr_number_of_features ; f++)
        {
            float m = (max[f]-min[f]);
            if(m > 0.0) 
            {
                input[f]=(input[f]-min[f])/m;
                input[f]=2*input[f]-1;
            }else
                input[f] = 0.0;
        }
     }  
    newdata->RefreshDataInfo();
    return newdata;
}
