#include "Parameters.h"

void Parameters::ParseArguments(int argc, char **argv)
{
    int i=1;
    if(argc == 1)
    {
            Usage();
            exit(1);
    }
    
    while(i<argc)
    {
        char *ap=argv[i];
        //floatingpoint parameters
       
        if (!strcmp(ap,"--diffusion"))
                diffusion = atof(argv[++i]);

        else if (!strcmp(ap,"--random") || !strcmp(ap,"-r"))
        {
                probability = atof(argv[++i]);
                wgenerate = g_random;
        }

        //integer parameters
        else if (!strcmp(ap,"--dim") || !strcmp(ap,"-d"))
                dim=atoi(argv[++i]);
        else if (!strcmp(ap,"-cv") || !strcmp(ap,"--crossvalidation-folds"))
                 nr_cv = atoi(argv[++i]);
        else if (!strcmp(ap,"--crossvalidation-method"))
        {
            if(!strcmp(argv[i+1],"random")) cv_method=monte_carlo;
            if(!strcmp(argv[i+1],"stratified")) cv_method=stratified;
            i++;		
        }
    
        else if (!strcmp(ap,"-tn") || !strcmp(ap,"--number-of-tests"))
            nr_test = atoi(argv[++i]);
        
        else if (!strcmp(ap,"-o"))
                output_file=argv[++i];
        
        else if (!strcmp(ap,"-id"))
                idFile=argv[++i];

        else if (!strcmp(ap,"--data-type"))
        {
            if(!strcmp(argv[i+1],"table")) datatype = table_with_labels;
            if(!strcmp(argv[i+1],"list")) datatype = list_of_ints;
            if(!strcmp(argv[i+1],"generate")) datatype = generated;
            i++;		
        }

   
        else if (!strcmp(ap,"--transformation"))
        {
            if(!strcmp(argv[i+1],"none")) trans = none;
            if(!strcmp(argv[i+1],"standarization")) trans = standarization;
            if(!strcmp(argv[i+1],"normalization")) trans = normalization;
            if(!strcmp(argv[i+1],"binarization")) trans = binarization;
            i++;
        }

        else if (!strcmp(ap,"--operation"))
        {
            if(!strcmp(argv[i+1],"stat")) operation = o_stat;
            if(!strcmp(argv[i+1],"select")) operation = o_select;
            if(!strcmp(argv[i+1],"clear")) operation = o_clear;
            i++;
        }
        
        else if (!strcmp(ap,"--format")||!strcmp(ap,"-f"))
        {
            if(!strcmp(argv[i+1],"snns")) d_format = snns;
            if(!strcmp(argv[i+1],"sca")) d_format = sca;
            i++;
        }


        //flags
        else if (!strcmp(ap,"--consistent")) remove_inconsistent = true;
        else if (!strcmp(ap,"--parity") || !strcmp(ap,"-p")) wgenerate = g_parity;
	else if (!strcmp(ap,"--value2bool")) wgenerate = g_value2bool;
        else if (!strcmp(ap,"-v")) debug_level=1;
        else if (!strcmp(ap,"-vv")) debug_level=2;
        else if (!strcmp(ap,"-vvv")) debug_level=3;
        else if (!strcmp(ap,"-vvvv")) debug_level=4;
        else if (!strcmp(ap,"-h") || !strcmp(ap,"--help"))
        {
            Usage();
            exit(0);
        }
        else
        {
              if(operation == o_stat|| operation == o_select || operation == o_clear) train_file = ap;
              else if (wgenerate==g_value2bool) value = atoi(ap);
		else{
		  
                cout << "Parametr " << ap << " nieobslugiwany\n";
                Usage();
                exit(1);
             }
        }
        i++;
    }
}

void Parameters::DisplayParameters()
{
    cout << "Dimensions           \t" << dim << endl;
    if(wgenerate != g_none )
    {
        cout << "Generating             \t";
        if(wgenerate == g_parity)
            cout << "parity" << endl;
        else if(wgenerate == g_random)
            cout << "random function with p(c|1)=" << probability << endl;
    }     
    if(diffusion > 0.0)
        cout << "Diffusion             \t" << diffusion << endl;
    cout << "Output file           \t";
    if(output_file == NULL ) cout << "stdout\n"; else cout << output_file << endl;
    cout << "Output data format         \t";
    if(d_format == raw) cout << "raw\n";
    if(d_format == snns) cout << "snns\n";
    if(d_format == sca) cout << "sca\n";
    
/*	if(datatype == table_with_labels )
	{
        if(train_file!=NULL)
            cout << "Training file             \t" << train_file << endl;
	}

	if(datatype == list_of_ints )
	{
		cout << "Boolean functions file             \t" << train_file << endl;
		cout << "Dim. of boolean functions          \t" << dim << endl;
	}
	
	if(datatype == generated) 
		cout << "Training file             \t generated"  << endl;
	else 
	{
        if(train_file != NULL )		cout << "Training file                          \t" << train_file << endl;
        if(test_file != NULL )		cout << "Test file                              \t" << train_file << endl;
    }*/
}

void Parameters::Usage()
{
    cout << "datatools [FILE] [options] [--operation [stat|select|generate]] [--dim N] [--random N|--parity|--value2bool number] [-o output_file] [-f format]  \n\n";
    cout << "OPCJE:\n";
    cout << "\t-d N\n\t--dim N\tdimension of data (default 4)\n\n";
    cout << "\t-f [raw|snns|sca]\n\t--format [raw|snns|sca]\tformat of data file\n\n";
    cout << "\t-o\toutput file (cout, if not given)\n\n";
    cout << "\t-p\n\t--parity\tgenerate parity data\n\n";
    cout << "\t--value2bool\tcreate binary data from given integer number\n\n";
    cout << "\t-r N\n\t--random N\tgenerate random boolean function with probability P(label = 1)=N\n\n";
    cout << "\t--diffusion N\tperturbate N pertcentage of labels in data\n\n";
    cout << "\t--operation [stat|select|generate]\toperations performed on data\n";
    cout << "\t\tstat\t display data statistics\n";
    cout << "\t\tselect\t create new data containing only selected (-id file) vectors\n";
    cout << "\t\tgenerate\t create new dataset (e.g. patiry data)\n";
    cout << "\t\tclear\t removes inconsistent vectors\n";
    cout << "\t--consistent\t remove all inconsistent data\n";
    
//    cout << "  -cv liczba\t --number-of-crossvalidation-folds liczba\n\tliczba foldow kroswalidacyjnych (default 10)\n\n";
//    cout << "  --crossvalidation-method [stratified|random]	\n\t metoda kroswalidacji (default stratified)\n\n";
//    cout << "  -nt liczba\t--number-of-tests liczba\n\tliczba powtorzen testu (default 10)\n\n";
//    cout << " -train plik\n\tplik treningowy\n\n";
//    cout << " -test plik\n\tplik testowy\n\n";
//    cout << " --data-type [table|list]\n\treprezentacja danych w pliku wejsciowym (default table)\n\n";
//    cout << " --transformation [normalization|standarization|binarization]\n\tinput data transformation (default none)\n\n";
//    cout << " --input [linear|sigmoid|ssigmoid|bicentral]\n\ttyp neuronow wejsciowych (default linear)\n\n";
    cout << "\t-v|-vv|-vvv\tlevel of verbosity\n\n";
}

