//
// C++ Implementation: RandomID
//
// Description: 
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "RandomID.h"
unsigned int RandomID::seed = 1;

RandomID::RandomID( ):id_tab(NULL),size(0),current(0)
{
    time_t g_time;
    g_time=time(&g_time);
    seed = (unsigned int)(g_time + rand());
    srand(seed);
}

RandomID::RandomID( int size )
{
    time_t g_time;
    g_time=time(&g_time);
    seed = (unsigned int)(g_time + rand());
    srand(seed);

    id_tab = NULL;
    Clear(size);
}

RandomID::~ RandomID( )
{
    delete [] id_tab;
}

void RandomID::Clear( int size )
{
    this->size = size;
    
    if(id_tab) delete id_tab;
    id_tab = new int[size];
    if(!id_tab) throw new MemoryException("RandomID - not enought memory");
    for (int i=0;i<size;i++)
        id_tab[i]=i;
    
    Resample();
}

void RandomID::Resample( )
{
    
    current = 0;

/*    time_t g_time;
    g_time=time(&g_time);
    unsigned int seed = rand();
    srand((unsigned int) g_time + seed);*/
    int k=0;
    int tmp=0;
    srand(seed);    
    
    int randomNumber;
    
    for(int i = 0;i<size;i++)
    {
       // k=rand()%(size-i);

        randomNumber = rand();
        k = (int)((float)size * randomNumber/(RAND_MAX + 1.0));  //kozysta z bardziej znaczacych bitow

        tmp=id_tab[size-i-1];
        id_tab[size-i-1]=id_tab[k];
        id_tab[k]=tmp;
    }
    RandomID::seed = randomNumber;
}

int RandomID::Next( )
{
    if(current >= size ) 
    {
        current%=size;
        Resample();
    }
    return id_tab[current++];
}

int RandomID::operator *(  )
{
    return Next();
}
