#ifndef __TESTER_H
#define __TESTER_H

#include <iostream>

#include "Parameters.h"
#include "Model.h"
#include "Data.h"
#include "Results.h"
#include "RandomID.h"

using namespace std;

class SimpleTest: public Tester
{
	Data *train_data;
public:
	SimpleTest()
	{
		train_data=NULL;
	}

	void Configure(Parameters &p){};
	void AddModel(Model *m){ model = m;}
	void AddTrainData(Data *d){train_data=d;}  //jesli nie dodamy danych treningowych to zakladamy, ze model jest nauczony
	void Run(Data *test_data);
	void DisplayResults();
	Results *GetResults();
};

class CrossValidation : public Tester
{
	int nr_of_folds;
	CV_type type;

	struct FoldsTable
	{
		Data *train;
		Data *test;
	} *folds;

   void MonteCarlo(Data *d);
	void Stratified(Data *d);

public:

	CrossValidation()
	{
		nr_of_folds=10;
		type=monte_carlo;
		folds=NULL;
	};

	void DisplayResults();
	Results *GetResults();
	void AddModel(Model *m){model=m;}
	void Run(Data *d);
	void Configure(Parameters &p);
	~CrossValidation();
};

class XTest : public Tester
{
	Parameters *init_param;
	int nr_of_tests;
public:
	XTest()
	{
		nr_of_tests=10;
		init_param=NULL;
	};

	void DisplayResults();
	Results *GetResults();
	void AddModel(Model *m){model=m;}
	void Run(Data *d);
	void Configure(Parameters &p);
};

#endif
