/***************************************************************************
 *   Copyright (C) 2007 by Marek Grochowski   *
 *   marek@is.umk.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <cstdlib>

#include "Parameters.h"
#include <time.h>
#include "test.h"

using namespace std;

int main(int argc,char **argv)
{

    //read config file and parse input arguments 
    Parameters p;
 //   p.ReadConfigFile("config");
    p.ParseArguments(argc,argv);
    
    clock_t tic=clock();
    time_t rawtime;
    time ( &rawtime );

    if(p.debug_level > 0 )
    {
        p.DisplayParameters();
    
        cout <<  "\nStarting time: " << ctime(&rawtime) << endl;
    }        
    cout.setf(std::ios_base::fixed);
    cout.precision(4);

/*****************************************************************
*    here we goooooooooooooooo
*******************************************************/
try
{
//  KenrelTransformationAndCV(p);
/*    p.train_file = "iris.set";
    p.operation = o_select;
    p.idFile = "idfile";
    p.d_format = sca;*/

    if(p.operation == o_stat) DisplayStatisctics(p);
    else if(p.operation == o_select ) SelectVectors(p);
    else if(p.operation == o_clear ) RemoveInconsistency(p);
    else DataCreator(p);
}
catch(Exception *e)
{
    e->Info();
}

/*****************************************************************
*    and that's almost everyfing 
*******************************************************/

    //finish the clock
    clock_t toc=clock();
    time ( &rawtime );
    if(p.debug_level > 0)
    {
        cout <<  "End time: " << ctime(&rawtime);
        float time_elapsed=(toc-tic)
                     /*/CLK_TCK */
                     /CLOCKS_PER_SEC
                     ;
        cout << "\nTime elapsed: " << time_elapsed << " s.\n";
     }
}
