//
// C++ Interface: exceptions
//
// Description: 
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include <iostream>
#ifndef __EXCEPTION_H
#define __EXCEPTION_H
using namespace std;

class Exception
{
public:
    const char *text;
    Exception(char *_text):text(_text){};
    virtual void Info()
    {
        cerr << "Exception occured: " << text << endl;
    }
};

class MemoryException : public Exception
{
public:
    MemoryException(char *_text):Exception(_text){};
    void Info()
    {
        cerr << "Memory allocation fails: " << text << endl;
    }
};

class FileException : public Exception
{
public:
    FileException(char *_text):Exception(_text){};
    void Info()
    {
        cerr << "File operation fails: " << text << endl;
    }
};


#endif
