//
// C++ Implementation: test
//
// Description: wszelakie testy i eksperymenty
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "test.h"


// void KenrelTransformationAndCV( Parameters & p )
// {
//     Data *data = new Data();
//    // data->ReadData( p.train_file );
//      data->ReadData( "iris_norm.dat" );
//     data->DisplayDataInfo();          
//     //data->DisplayData();
//     
//     
//     KernelTransformation kt;
//     kt.Configure(p);
//     kt.SetKernel(1);
//     
//     Data *dl = kt.Learn( data );
//   //  Data *dd = kt.Run( data );
//     dl->DisplayData();
//     dl->DisplayDataInfo();
//     dl->DisplayLabelsInfo();
//     dl->DisplayStatistics();
// /*    KernelNetwork knet;
//     knet.Configure( p );
//     
//     SimpleTest st;
//     st.AddModel(&knet);
//     st.AddTrainData( data );
//     st.Configure( p );
//     st.Run( data );*/
//     
//   /*  CrossValidation cv;
//     cv.Configure(p);
//     cv.AddModel(&knet);
//                 
//     XTest xt;
//     xt.Configure(p);
//     xt.AddModel(&cv);
//     xt.Run(data);
//     xt.DisplayResults();                    
//   */ 
//   delete data;
//    
// 
// 
// }

void DataCreator( Parameters & p )
{
    srand ( time(NULL) );
    BinaryData *data = new BinaryData();
    if(p.wgenerate == g_parity ) data->CreateParityFunction( p.dim);
    if(p.wgenerate == g_random ) data->CreateRandomBooleanFunction( p.dim, p.probability );
    if(p.wgenerate == g_value2bool) data->CreateDataFromBooleanFunction(p.value,p.dim);
    if(p.diffusion > 0) data->DataLabelDiffuzion(p.diffusion);
    
    if( p.debug_level > 0 ) data->DisplayDataInfo();    
    if( p.trans == normalization) 
    {
        Normalization norm;
        Data *newdata = norm.Learn(data);
        data->~Data();
        data = (BinaryData *)newdata;
    }
    
    data->Save(p.output_file,p.d_format);
    
    delete data;

}

void DisplayStatisctics(Parameters & p)
{
    Data d;
    d.ReadData(p.train_file,p.d_format);
    d.DisplayStatistics();
}

void SelectVectors(Parameters & p)
{
    Data d;
    d.ReadData(p.train_file,p.d_format);
    long nov = d.GetNumberOfVectors();
    ifstream in;
    BitVector *bv = NULL;
    
    if(p.idFile == NULL)
        bv =ReadId(nov,cin);
    else
    {
        in.open(p.idFile);
        if(!in) throw new FileException(p.idFile);
        bv = ReadId(nov,in);
    }
    
    Data *newdata = d.SelectVectors(*bv);
    newdata->Save(p.output_file,p.d_format);       
    
    delete newdata,bv;
}

BitVector * ReadId(long vectors, istream & in)
{
    BitVector *bv = new BitVector(vectors);
    bv->Clear(0);
    long dummy =0;
    
    while(!in.eof())
    {
        in >> dummy;
        if((dummy < 1 )||( dummy > vectors)) cerr << "Vector nr " << dummy << " don't exist" << endl;
        else bv->SetBitOn(dummy-1);
    }
    return bv;
}

void RemoveInconsistency(Parameters & p)
{
    Data d;
    d.ReadData(p.train_file,p.d_format);
    
    InconsistencyFilter ic;
    ic.Configure(p);
    
    Data *newdata = ic.Run(&d);
    cout << ic;
    
    newdata->Save(p.output_file,p.d_format);  
    delete newdata;
}
